package main

/*
	this parses the command line arguements

	this enables command line options from other packages like 'gui' and 'log'
*/

import (
	"go.wit.com/dev/alexflint/arg"
	"go.wit.com/lib/debugger"
	"go.wit.com/log"
)

var args struct {
	DownloadAll   bool `arg:"--download-all" help:"download everything from go.wit.com"`
	GitPull       bool `arg:"--git-pull" help:"do git pull in every repository"`
	CheckoutUser  bool `arg:"--switch-to-user-branch" help:"switch everything to your user branch"`
	CheckoutDevel bool `arg:"--switch-to-devel-branch" help:"switch everything to the devel branch"`
	OnlyMe        bool `arg:"--only-me" help:"only scan repos from ~/.config/autotypist"`
}

func init() {
	arg.MustParse(&args)

	if debugger.ArgDebug() {
		log.Info("cmd line --debugger == true")
		go func() {
			log.Sleep(2)
			debugger.DebugWindow()
		}()
	}
}
