package main

import (
	"go.wit.com/gui"
	"go.wit.com/lib/debugger"
	"go.wit.com/lib/gui/gowit"
	"go.wit.com/lib/gui/logsettings"
)

func globalDisplaySetRepoState() {
	for _, repo := range me.allrepos {
		if me.autoHideReadOnly.Checked() {
			if repo.status.ReadOnly() {
				repo.Hide()
				continue
			}
		}
		if me.autoHidePerfect.Checked() {
			if repo.dirtyLabel.String() == "PERFECT" {
				repo.Hide()
				continue
			}
		}
		repo.Show()
	}
}

func globalDisplayShow() {
	for _, repo := range me.allrepos {
		if me.autoHideReadOnly.Checked() {
			if repo.status.ReadOnly() {
				continue
			}
		}
		if me.autoHidePerfect.Checked() {
			if repo.dirtyLabel.String() == "PERFECT" {
				continue
			}
		}
		repo.Show()
	}
}

func globalDisplayOptions(vbox *gui.Node) {
	group1 := vbox.NewGroup("Global Display Options")

	group1.NewButton("Show Repository Window", func() {
		globalDisplaySetRepoState()
		me.reposwin.Toggle()
	})

	me.autoHideReadOnly = group1.NewCheckbox("Hide read-only repos").SetChecked(true)
	me.autoHideReadOnly.Custom = func() {
		if me.autoHideReadOnly.Checked() {
			globalDisplaySetRepoState()
		} else {
			globalDisplayShow()
		}
	}

	me.autoHidePerfect = group1.NewCheckbox("Hide Perfectly clean repos").SetChecked(true)
	me.autoHidePerfect.Custom = func() {
		if me.autoHidePerfect.Checked() {
			globalDisplaySetRepoState()
		} else {
			globalDisplayShow()
		}
	}
	me.scanEveryMinute = group1.NewCheckbox("Scan every minute").SetChecked(false)

	var tagsW *tagWindow
	group1.NewButton("git tags Window", func() {
		if tagsW == nil {
			tagsW = makeTagWindow()
		} else {
			tagsW.win.Toggle()
		}
	})

	var listallB *gui.Node
	listallB = group1.NewButton("go.wit.com", func() {
		listallB.Disable()
		if me.lw == nil {
			me.lw = gowit.ListWindow()
		}
		if me.lw.Hidden() {
			me.lw.Show()
		} else {
			me.lw.Hide()
		}
		listallB.Enable()
	})
}

func debuggerBox(vbox *gui.Node) {
	group2 := vbox.NewGroup("Debugger")
	group2.NewButton("logging Window", func() {
		logsettings.LogWindow()
	})

	group2.NewButton("Debugger Window", func() {
		debugger.DebugWindow()
	})
}

func hidePerfect() {
	for _, repo := range me.allrepos {
		if repo.dirtyLabel.String() == "PERFECT" {
			if repo.hidden {
				continue
			}
			repo.Hide()
			// return
		}
	}
}
