package main

import (
	"fmt"
	"os"
	"path/filepath"

	"go.wit.com/gui"
	"go.wit.com/lib/gui/shell"
	"go.wit.com/log"
)

func docsBox(vbox *gui.Node) {
	group := vbox.NewGroup("Docs")

	group.NewButton("make 'go.work' file", func() {
		me.autotypistWindow.Disable()

		goSrcDir := me.goSrcPwd.String()
		filename := filepath.Join(goSrcDir, "go.work")

		f, err := os.OpenFile(filename, os.O_WRONLY|os.O_CREATE, 0600)
		if err != nil {
			return
		}
		defer f.Close()
		fmt.Fprintln(f, "go 1.21.4")
		fmt.Fprintln(f, "")
		fmt.Fprintln(f, "use (")
		for _, repo := range me.allrepos {
			if repo.status.Exists("go.mod") {
				fmt.Fprintln(f, "\t"+repo.String())
			} else {
				log.Info("missing go.mod for", repo.String())
				repo.status.MakeRedomod()
			}
		}
		fmt.Fprintln(f, ")")

		me.autotypistWindow.Enable()
	})

	group.NewButton("run pkgsite", func() {
		tmp := me.userHomePwd.String()
		tmpDir := filepath.Join(tmp, "go/src")
		os.Chdir(tmpDir)
		pkgsite := filepath.Join(tmp, "go/bin", "pkgsite")
		os.Unsetenv("GO111MODULE")
		go shell.Run([]string{pkgsite})
		shell.Run([]string{"ping", "-c", "3", "git.wit.org"})
	})

	group.NewButton("send docs to browser (localhost:8080)", func() {
		me.autotypistWindow.Disable()
		defer me.autotypistWindow.Enable()

		shell.OpenBrowser("http://localhost:8080")
	})
}
